define("io.ox/office/tk/locale/parser",["io.ox/office/tk/utils","io.ox/office/tk/utils/dateutils","io.ox/office/tk/object/arraytemplate","io.ox/office/tk/locale/localedata"],function(a,b,c,d){"use strict";function e(a,b,c){this.type=a,this.text=b,this.length=c}function f(){this.tokens=new n,this.category="custom",this.colorName=null,this.rgbColor=null,this.operator=null,this.boundary=0,this.autoMinus=!0,this.flags={general:!1,integer:!1,"float":!1,percent:0,scientific:!1,fraction:!1,fractionCode:"",floatCode:"",currency:!1,date:!1,time:!1,ampm:!1,text:!1,fill:!1}}function g(a){this.formatCode=a,this.numberSections=new o,this.textSection=null,this.syntaxError=!1,this.category="custom"}var h={black:"000000",blue:"0000FF",cyan:"00FFFF",green:"00FF00",magenta:"FF00FF",red:"FF0000",white:"FFFFFF",yellow:"FFFF00"},i=new RegExp("^\\[("+_.keys(h).join("|")+")\\]","i"),j=["$","£","฿","₡","₩","₪","₫","€","₮","￥"],k=new RegExp("^("+j.map(_.escapeRegExp).join("|")+")"),l={trad:{Y:"年",M:"月",D:"日",h:"時",m:"分",s:"秒"},simp:{Y:"年",M:"月",D:"日",h:"时",m:"分",s:"秒"},hang:{Y:"년",M:"월",D:"일",h:"시",m:"분",s:"초"}},m=_.memoize(function(a){return a=_.escapeRegExp(a),new RegExp("^([-+]?)((?:\\d*"+a+"\\d+|\\d+"+a+"?)(?:E[-+]?\\d+)?)","i")}),n=c.create(e);f.prototype.pushToken=function(a){this.tokens.push(new e(a,"",0))},f.prototype.pushTextToken=function(a,b){var c=this.tokens.last();c&&c.type===a?c.text+=b:this.tokens.push(new e(a,b,0))},f.prototype.pushLiteralToken=function(a){this.pushTextToken("lit",a)},f.prototype.pushDateToken=function(a,b){this.tokens.push(new e(a,"",b)),this.flags.date=!0},f.prototype.pushTimeToken=function(a,b){this.tokens.push(new e(a,"",b)),this.flags.time=!0},f.prototype.pushAmPmToken=function(a){this.pushTimeToken("ampm",a),this.flags.ampm=!0},f.prototype.setColor=function(b){b in h?(this.colorName=b,this.rgbColor=h[b]):a.error('FormatSection.setColor(): invalid color "'+b+'"')},f.prototype.setInterval=function(b,c,d){if(!d||!this.operator){switch(b){case"<":this.autoMinus=c>0;break;case"<=":this.autoMinus=c>=0;break;case">":case">=":this.autoMinus=0>c;break;case"=":this.autoMinus=!1;break;case"<>":this.autoMinus=!0;break;default:return void a.error('FormatSection.setInterval(): invalid interval operator "'+b+'"')}this.operator=b,this.boundary=c}},f.prototype.contains=function(a){switch(this.operator){case"<":return a<this.boundary;case"<=":return a<=this.boundary;case">":return a>this.boundary;case">=":return a>=this.boundary;case"=":return a===this.boundary;case"<>":return a!==this.boundary}return!0},f.parse=function(b){for(var c=new f,d=c.flags,e=null,g=!1,h=!1,j=!1;!g&&!h&&b.length>0;)try{if(e=/^;/.exec(b)){h=!0;continue}if(e=/^GENERAL/i.exec(b)){c.pushToken("general"),d.general=!0;continue}if(e=/^\.[0?#]+/i.exec(b)){c.pushTextToken("sign",e[0]),d["float"]=!0,d.floatCode=e[0];continue}if(e=/^[0?#]+\/[0-9?#]+/i.exec(b)){c.pushTextToken("frac",e[0]),d.fraction=!0,d.fractionCode=e[0];continue}if(e=/^,?[0#?]+,?/.exec(b)){c.pushTextToken("nr",e[0]),d.integer=!0;continue}if(e=/^E[-+]([0?#]+)/i.exec(b)){c.pushTextToken("scien",e[1]),d.scientific=!0;continue}if(e=/^AM\/PM/i.exec(b)){c.pushAmPmToken(2);continue}if(e=/^A\/P/i.exec(b)){c.pushAmPmToken(1);continue}if(e=/^Y+/i.exec(b)){c.pushDateToken("year",Math.min(4,a.roundUp(e[0].length,2))),j=!1;continue}if(e=/^M+/.exec(b)){c.pushDateToken("month",Math.min(5,e[0].length)),j=!1;continue}if(e=/^D+/i.exec(b)){c.pushDateToken("day",Math.min(4,e[0].length)),j=!1;continue}if(e=/^\[(h+)\]/i.exec(b)){c.pushTimeToken("hours",e[1].length),j=!0;continue}if(e=/^\[(m+)\]/.exec(b)){c.pushTimeToken("minutes",e[1].length);continue}if(e=/^\[(s+)\]/i.exec(b)){c.pushTimeToken("seconds",e[1].length),j=!1;continue}if(e=/^h+/i.exec(b)){c.pushTimeToken("hour",Math.min(2,e[0].length)),j=!0;continue}if(e=/^(m+)(?=\W+s)/i.exec(b)){c.pushTimeToken("minute",Math.min(2,e[1].length)),j=!1;continue}if(e=/^m+/.exec(b)){j?c.pushTimeToken("minute",Math.min(2,e[0].length)):c.pushDateToken("month",Math.min(5,e[0].length)),j=!1;continue}if(e=/^s+/i.exec(b)){c.pushTimeToken("second",Math.min(2,e[0].length)),j=!1;continue}if(e=/^%/.exec(b)){c.pushLiteralToken("%"),d.percent+=1;continue}if(e=/^"([^"]*)"/.exec(b)){c.pushLiteralToken(e[1]);continue}if(e=/^\\(.)/.exec(b)){c.pushLiteralToken(e[1]);continue}if(e=/^_./.exec(b)){c.pushLiteralToken(" ");continue}if(e=/^\*(.)/.exec(b)){d.fill?c.pushLiteralToken(e[1]):(c.pushTextToken("fill",e[1]),d.fill=!0);continue}if(e=/^\[(<=?|>=?|<>|=)([^[\];]+)\]/.exec(b)){var l=p.parseLeadingNumber(e[2],{dec:".",sign:!0,complete:!0});l&&0===l.remaining.length?c.setInterval(e[1],l.number):g=!0;continue}if(e=i.exec(b)){c.setColor(e[1].toLowerCase());continue}if(e=/^\[\$-([0-9a-f]+)\]/i.exec(b))continue;if(e=/^\[\$([^[\];-]+)-([0-9a-f]+)\]/i.exec(b)){c.pushLiteralToken(e[1]),d.currency=!0;continue}if(e=/^\[\$([^[\];-]+)\]/i.exec(b)){c.pushLiteralToken(e[1]),d.currency=!0;continue}if(e=k.exec(b)){c.pushLiteralToken(e[1]),d.currency=!0;continue}if(e=/^(\[[^[\];]*\])/.exec(b)){a.warn('FormatSection.parse(): unsupported section specifier "'+e[1]+'"');continue}if(e=/^@/.exec(b)){c.pushToken("text"),d.text=!0;continue}if(/^["\[\\_*]/.test(b)){g=!0;continue}e=[b[0]],c.pushLiteralToken(e[0])}finally{b=b.slice(e[0].length)}return g||(d.text?(c.category="text",g=d.general||d.integer||d["float"]||d.percent||d.scientific||d.fraction||d.date||d.time):d.general&&1===c.tokens.length?c.category="standard":d.general||!d.integer&&!d["float"]||d.date||d.time?d.general||d.integer||d.percent||d.scientific||d.fraction||(!d.date||d.time||d["float"]?!d.date&&d.time?c.category="time":d.date&&d.time&&(c.category="datetime"):c.category="date"):d.percent||d.scientific||d.fraction||d.currency?!d.percent||d.scientific||d.fraction||d.currency?d.percent||!d.scientific||d.fraction||d.currency?d.percent||d.scientific||!d.fraction||!d.integer||d["float"]||d.currency?d.percent||d.scientific||d.fraction||!d.currency||(c.category="currency"):c.category="fraction":c.category="scientific":c.category="percent":c.category="number"),{section:g?null:c,remainder:h?b:null}};var o=c.create(f);g.prototype.parseSection=function(a){var b=f.parse(a);return b.section?this.textSection?(this.syntaxError=!0,null):("text"===b.section.category?this.textSection=b.section:this.numberSections.push(b.section),b.remainder):(this.syntaxError=!0,null)},g.prototype.getSection=function(a){return this.syntaxError?null:_.isString(a)?this.textSection:_.isNumber(a)&&isFinite(a)?this.numberSections.find(function(b){return b.contains(a)}):null},g.prototype.isStandard=function(){return"standard"===this.category},g.prototype.isAnyDate=function(){return/^date(time)?$/.test(this.category)},g.prototype.isAnyTime=function(){return/^(date)?time$/.test(this.category)},g.prototype.isAnyDateTime=function(){return/^(date|time|datetime)$/.test(this.category)};var p={};return p.numberToString=function(a){return String(a).replace(/\./g,d.DEC)},p.stringToNumber=function(a){return parseFloat(a.replace(d.DEC,"."))},p.parseLeadingNumber=function(b,c){var e=a.getStringOption(c,"dec",d.DEC),f=a.getBooleanOption(c,"sign",!1),g=a.getBooleanOption(c,"complete",!1),h=m(e).exec(b),i=null;return!h||!f&&h[1].length>0?null:g&&h[0].length<b.length?null:(i=parseFloat(h[2].replace(e,".")),_.isFinite(i)?("-"===h[1]&&(i=-i),{number:i,text:h[0],sign:h[1],remaining:b.substr(h[0].length)}):null)},p.parseLeadingDate=function(){function c(a,b,c){var d=f(b,c).exec(a);if(!d)return null;var e={D:null,M:null,Y:null,text:d[0],remaining:a.substr(d[0].length)};return _.each(b,function(a,b){e[a]=parseInt(d[b+1],10)}),_.isNumber(e.M)&&(e.M-=1),e}function e(e,f){var g=a.getStringOption(f,"dec",d.DEC),h=a.getBooleanOption(f,"leadingMonth",d.LEADING_MONTH),i=a.getBooleanOption(f,"leadingYear",d.LEADING_YEAR),j=h?"MD":"DM",k=[i?"Y"+j:j+"Y",i?j+"Y":"Y"+j,j,i?"YM":"MY",i?"MY":"YM"],l=null;if(k.some(function(a){return l=c(e,a,g)}),!l)return null;var m=a.getBooleanOption(f,"complete",!1);if(m&&l.remaining.length>0)return null;var n=a.getIntegerOption(f,"centuryThreshold",100,0,100),o=_.isNumber(l.Y)?b.expandYear(l.Y,n):(new Date).getFullYear(),p=_.isNumber(l.M)?l.M:0,q=_.isNumber(l.D)?l.D:1;return q>b.getDaysInMonth(o,p)?null:(l.date=b.makeUTCDate({Y:o,M:p,D:q}),isFinite(l.date.getTime())?l:null)}var f=_.memoize(function(a,b){var c="."===b?"[-/]":"[-./]",d="";return _.each(a,function(a){switch(d&&(d+="\\s*"+c+"\\s*"),a){case"D":d+="([12]\\d|3[01]|0?[1-9])";break;case"M":d+="(1[0-2]|0?[1-9])";break;case"Y":d+="(\\d{4}|\\d\\d?)"}}),new RegExp("^"+d)},function(a,b){return a+b});return e}(),p.parseLeadingTime=function(){function b(a,b,c){var d=e(b,c).exec(a);if(!d)return null;var f={h:null,m:null,s:null,ms:null,text:d[0],remaining:a.substr(d[0].length)};return _.each(b,function(a,b){var c=d[b+1];"0"===a?f.ms=1e3*parseFloat("0."+c):f[a]=parseInt(c,10)}),f}function c(c,e){var f=a.getStringOption(e,"dec",d.DEC),g=a.getBooleanOption(e,"milliseconds",!1),h=g?["hms0","hm","ms0"]:["hms","hm"],i=null;if(h.some(function(a){return i=b(c,a,f)}),!i)return null;var j=a.getBooleanOption(e,"complete",!1);if(j&&i.remaining.length>0)return null;var k=a.getBooleanOption(e,"multipleDays",!1);return!k&&_.isNumber(i.h)&&i.h>23?null:(i.time=new Date(0),_.isNumber(i.h)&&i.time.setUTCHours(i.h),_.isNumber(i.m)&&i.time.setUTCMinutes(i.m),_.isNumber(i.s)&&i.time.setUTCSeconds(i.s),_.isNumber(i.ms)&&i.time.setUTCMilliseconds(i.ms),i)}var e=_.memoize(function(a,b){var c="";return _.each(a,function(a){switch(c&&(c+="\\s*"+("0"===a?_.escapeRegExp(d.DEC):":")+"\\s*"),a){case"h":c+="(\\d{1,4})";break;case"m":case"s":c+="([0-5]?\\d)";break;case"0":c+=_.escapeRegExp(b)+"(\\d+)"}}),new RegExp("^"+c)},function(a,b){return a+b});return c}(),p.parseFormatCode=_.memoize(function(a){var b=new g(a);for(b.syntaxError=0===a.length;!b.syntaxError&&_.isString(a);)a=b.parseSection(a);var c=b.numberSections;if(0===c.length)b.category="text";else if(1===c.length&&"standard"===c[0].category)b.category="standard";else{var d=_.unique(_.pluck(c,"category"));b.category=1===d.length?d[0]:"custom"}switch(c.length){case 0:c.push(new f),c[0].pushToken("general");break;case 1:break;case 2:c[0].setInterval(">=",0,!0),c[1].setInterval("<",0,!0);break;case 3:c[0].setInterval(">",0,!0),c[1].setInterval("<",0,!0),c[2].setInterval("=",0,!0);break;default:b.syntaxError=!0}return b.textSection?b.textSection.operator&&(b.syntaxError=!0):(b.textSection=new f,b.textSection.pushToken("text"),c[0].colorName&&"standard"===b.category&&b.textSection.setColor(c[0].colorName)),b}),p.generateCJKDateTimeFormat=function(a,b,c){var d=l[b];return a.replace(/{H}/g,(c&&c.ampm?"AM/PM":"")+(c&&c["long"]?"hh":"h")).replace(/{YEAR}/g,d.Y).replace(/{MONTH}/g,d.M).replace(/{DAY}/g,d.D).replace(/{HOUR}/g,d.h).replace(/{MINUTE}/g,d.m).replace(/{SECOND}/g,d.s)},p});